#
# Conditional build:
%bcond_without	fontconfig	# fontconfig support
%bcond_with	libimagequant	# LIQ quantization method support (breaks transparency in TrueColor->palette conversion)
%bcond_with	sse		# SSE math on ix86
%bcond_without	xpm		# XPM support (requires X11 libs)
%bcond_without	tests		# "make check"
#
%ifarch pentium3 pentium4
%define	with_sse	1
%endif
Summary:	Library for PNG, JPEG creation
Summary(es.UTF-8):	Biblioteca para manipulación de imágenes
Summary(pl.UTF-8):	Biblioteka do tworzenia grafiki w formacie PNG, JPEG
Summary(pt_BR.UTF-8):	Biblioteca para manipulação de imagens
Name:		gd
Version:	2.2.5
Release:	4
License:	BSD-like
Group:		Libraries
#Source0Download: https://github.com/libgd/libgd/releases
Source0:	https://github.com/libgd/libgd/releases/download/%{name}-%{version}/lib%{name}-%{version}.tar.xz
# Source0-md5:	8d8d6a6189513ecee6e893b1fb109bf8
Patch0:		%{name}-fontpath.patch
Patch2:		%{name}-loop.patch
Patch3:		%{name}-liq.patch
Patch4:		0004-Fix-OOB-read-due-to-crafted-GD-GD2-images.patch
Patch5:		0005-Fix-tiff_invalid_read-check.patch
Patch6:		bmp-check-return-value-in-gdImageBmpPtr.patch
Patch7:		Fix-420-Potential-infinite-loop-in-gdImageCreateFrom.patch
URL:		https://libgd.github.io/
BuildRequires:	autoconf >= 2.54
BuildRequires:	automake
%{?with_fontconfig:BuildRequires:	fontconfig-devel}
BuildRequires:	freetype-devel >= 1:2.1.10
BuildRequires:	gettext-tools
%{?with_libimagequant:BuildRequires:	libimagequant-devel}
BuildRequires:	libjpeg-devel
BuildRequires:	libpng-devel >= 2:1.4.0
BuildRequires:	libtiff-devel >= 4
BuildRequires:	libtool >= 2:2
BuildRequires:	libwebp-devel
BuildRequires:	pkgconfig
BuildRequires:	sed >= 4
BuildRequires:	tar >= 1:1.22
%{?with_xpm:BuildRequires:	xorg-lib-libXpm-devel}
BuildRequires:	xz
BuildRequires:	zlib-devel
Requires:	freetype >= 1:2.1.10
Provides:	gd(gif) = %{version}-%{release}
# versioned by php version rotate_from_php code comes from
Provides:	gd(imagerotate) = 5.2.0
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
gd is the image manipulating library. It was created to allow graphs,
charts and the like to be generated on the fly for use on the World
wide Web, but is useful for any application in which custom images are
useful. It is not a paint program; it is a library. gd library creates
PNG, JPEG, GIF and WBMP images. PNG is a more compact format, and full
compression is available. JPEG works well with photographic images,
and is still more compatible with the major Web browsers than even PNG
is. WBMP is intended for wireless devices (not regular web browsers).

%description -l es.UTF-8
Esta es la biblioteca gd para el manejo de imágenes. Fue creada para
uso en la Web, creando gráficos automáticamente. Pero es útil para
cualquier programa que necesite de imágenes personalizados. No es un
programa de dibujo; es una biblioteca.

%description -l pl.UTF-8
gd to biblioteka do obróbki obrazów. Została stworzona, aby umożliwić
dynamiczne generowanie wykresów i podobnych rzeczy na potrzeby WWW,
ale może być przydatna także dla każdej aplikacji tworzącej własne
obrazy. Biblioteka ta pozwala na tworzenie plików graficznych w
formatach PNG, JPEG, GIF i WBMP. PNG jest zwartym formatem z
bezstratną kompresją. JPEG dobrze nadaje się do obrazów
fotograficznych i jest obsługiwany nawet przez więcej przeglądarek WWW
niż PNG. WBMP jest przeznaczony dla urządzeń bezprzewodowych (a nie
zwykłych przeglądarek WWW).

%description -l pt_BR.UTF-8
Esta é a biblioteca gd para manipulação de imagens. Ela foi criada
para uso na Web, gerando gráficos automaticamente. Mas é útil para
qualquer programa que precise de imagens personalizados. Não é um
programa de desenho; é uma biblioteca.

%package devel
Summary:	Development part of the GD library
Summary(es.UTF-8):	Archivos de inclusión y bibliotecas para desarrollar programas usando gd
Summary(pl.UTF-8):	Część biblioteki GD przeznaczona dla developerów
Summary(pt_BR.UTF-8):	Arquivos de inclusão e bibliotecas para desenvolver programas usando gd
Group:		Development/Libraries
Requires:	%{name} = %{version}-%{release}
Requires:	fontconfig-devel
Requires:	freetype-devel >= 1:2.1.10
%{?with_libimagequant:Requires:	libimagequant-devel}
Requires:	libjpeg-devel
Requires:	libpng-devel
Requires:	libtiff-devel >= 4
Requires:	libwebp-devel
%{?with_xpm:Requires:	xorg-lib-libXpm-devel}
Requires:	zlib-devel
Provides:	gd-devel(gif) = %{version}-%{release}
Provides:	gd-devel(imagerotate) = 5.2.0

%description devel
This package contains the files needed for development of programs
linked against GD.

%description devel -l es.UTF-8
Este paquete contiene los archivos de inclusión y las bibliotecas
necesarias para desarrollar programas usando gd.

%description devel -l pl.UTF-8
Pakiet ten zawiera pliki potrzebne do rozwoju programów korzystających
z biblioteki GD.

%description devel -l pt_BR.UTF-8
Este pacote contém os arquivos de inclusão e as bibliotecas
necessárias para desenvolver programas usando gd.

%package static
Summary:	Static GD library
Summary(pl.UTF-8):	Statyczna biblioteka GD
Summary(pt_BR.UTF-8):	Bibliotecas estáticas para desenvolvimento com libgd
Group:		Development/Libraries
Requires:	%{name}-devel = %{version}-%{release}
Provides:	gd-static(gif) = %{version}-%{release}
Provides:	gd-static(imagerotate) = 5.2.0

%description static
This package contains static gd library.

%description static -l pl.UTF-8
Ten pakiet zawiera statyczną bibliotekę gd.

%description static -l pt_BR.UTF-8
Este pacote contem bibliotecas estáticas para desenvolvimento com
libgd.

%package progs
Summary:	Utility programs that use libgd
Summary(es.UTF-8):	Programas utilitarios libgd
Summary(pl.UTF-8):	Narzędzia używające libgd
Summary(pt_BR.UTF-8):	Programas utilitários libgd
Group:		Applications/Graphics
Requires:	%{name} = %{version}-%{release}

%description progs
These are utility programs supplied with gd, the image manipulation
library. The libgd-progs package contains a group of scripts for
manipulating the graphics files in formats which are supported by the
libgd library.

%description progs -l pl.UTF-8
Ten pakiet zawiera programy używające biblioteki gd, służące do
obróbki plików graficznych w formatach obsługiwanych przez libgd.

%description progs -l pt_BR.UTF-8
Este pacote inclui vários utilitários para manipulação de arquivos gd
para uso pelos programas que usam a libgd.

%prep
%setup -q -n libgd-%{version}
%patch0 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1

# hack to avoid inclusion of -s in --ldflags
%{__sed} -i -e 's,@LDFLAGS@,,g' config/gdlib-config.in
# disable error caused by subdir-objects warning in automake 1.14
%{__sed} -i -e '/AM_INIT_AUTOMAKE/s/-Werror//' configure.ac

%build
%{__libtoolize}
%{__aclocal}
%{__automake}
%{__autoheader}
%{__autoconf}
%ifarch %{ix86}
%if %{with sse}
CFLAGS="%{rpmcflags} -msse -mfpmath=sse"
%endif
%endif
%configure \
	%{!?with_fontconfig:--without-fontconfig} \
	%{!?with_libimagequant:--without-liq} \
	%{!?with_xpm:--without-xpm}
%{__make}

%if %{with tests}
%ifarch %{ix86}
# https://github.com/libgd/libgd/issues/359
XFAIL_TESTS="$XFAIL_TESTS gdimagegrayscale/basic"
%if %{without sse}
# 387 arithmetic is inexact, https://github.com/libgd/libgd/issues/242
XFAIL_TESTS="$XFAIL_TESTS gdimagecopyresampled/bug00201 gdimagerotate/bug00067"
%endif
%endif
export XFAIL_TESTS
%{__make} check
%endif

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

%clean
rm -rf $RPM_BUILD_ROOT

%post	-p /sbin/ldconfig
%postun -p /sbin/ldconfig

%files
%defattr(644,root,root,755)
%doc CONTRIBUTORS COPYING README.md
%attr(755,root,root) %{_libdir}/libgd.so.*.*.*
%attr(755,root,root) %ghost %{_libdir}/libgd.so.3

%files devel
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/gdlib-config
%attr(755,root,root) %{_libdir}/libgd.so
%{_libdir}/libgd.la
%{_includedir}/entities.h
%{_includedir}/gd*.h
%{_pkgconfigdir}/gdlib.pc

%files static
%defattr(644,root,root,755)
%{_libdir}/libgd.a

%files progs
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/annotate
%attr(755,root,root) %{_bindir}/bdftogd
%attr(755,root,root) %{_bindir}/gd2copypal
%attr(755,root,root) %{_bindir}/gd2togif
%attr(755,root,root) %{_bindir}/gd2topng
%attr(755,root,root) %{_bindir}/gdcmpgif
%attr(755,root,root) %{_bindir}/gdparttopng
%attr(755,root,root) %{_bindir}/gdtopng
%attr(755,root,root) %{_bindir}/giftogd2
%attr(755,root,root) %{_bindir}/pngtogd
%attr(755,root,root) %{_bindir}/pngtogd2
%attr(755,root,root) %{_bindir}/webpng
%changelog
* Tue Jan 22 2019 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/gd.git;a=log;h=master

* Tue Jan 22 2019 Arkadiusz Miśkiewicz <arekm@maven.pl> f510b22
- rel 4; fixes from debian

* Thu Aug 16 2018 Jan Rękorajski <baggins@pld-linux.org> c3e9c51
- rebuild without libjpeg.la
- release 3 (by relup.sh)

* Tue Feb 13 2018 Jan Rękorajski <baggins@pld-linux.org> e619ff9
- release 2 (by relup.sh)

* Tue Feb 13 2018 Jan Rękorajski <baggins@pld-linux.org> 63ee803
- fix tests
- remove obsolete patch that only breaks stuff now

* Sat Oct 28 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 8688bbf
- up to 2.2.5

* Sun Apr 23 2017 Jakub Bogusz <qboosh@pld-linux.org> 74fcde3
- added upstream patch (taken from Fedora): fixes tiff_invalid_read test failure
- release 2

* Sat Apr 22 2017 Jakub Bogusz <qboosh@pld-linux.org> 7f9a7b0
- updated to 2.2.4 (fixes CVE-2016-6912 CVE-2016-9317)

* Sun Aug 28 2016 Jakub Bogusz <qboosh@pld-linux.org> 03167d1
- sse bcond fix (only custom setting was affected)

* Sun Aug 28 2016 Jakub Bogusz <qboosh@pld-linux.org> 35d1d5c
- new URLs, updated to 2.2.3 (fixes CVE-2015-8874 CVE-2016-3074 CVE-2016-5766 CVE-2016-5767 CVE-2016-6128 CVE-2016-6132 CVE-2016-6207 CVE-2016-6214)
- removed obsolete missing,version patches
- removed outdated libvpx2 patch (WebP is now supported via libwebp instead of libvpx)
- old liq patch obsolete; added new one which workarounds allocation alignment issues with SSE-enabled libimagequant
- set XFAIL for tests failing due to known reason
- disable liq by default (breaks transparency handling in TrueColor->palette conversion)

* Thu Dec 24 2015 Jan Rękorajski <baggins@pld-linux.org> da3a795
- release 5 (by relup.sh)

* Sun Jun 21 2015 Jakub Bogusz <qboosh@pld-linux.org> 010b44d
- added missing patch (missing script required to properly set version information)
- added version patch (fixes major and minor in gdlib-config script)
- added liq patch (allow to use libimagequant when using autoconf; ported from cmake files)
- release 4

* Fri Jun 19 2015 Jakub Bogusz <qboosh@pld-linux.org> 6d88d86
- noted new source URL

* Sat May 23 2015 Jan Rękorajski <baggins@pld-linux.org> 42ecee0
- release 3 (by relup.sh)

* Sat May 23 2015 Jan Rękorajski <baggins@pld-linux.org> 6d49f97
- fix building with libvpx 1.4 (libvpx.so.2)

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 3310b19
- x32 rebuild
- release 2 (by relup.sh)

* Wed Jan 14 2015 Jakub Bogusz <qboosh@pld-linux.org> 96bb8f7
- updated to 2.1.1

* Sun Dec 28 2014 Jan Rękorajski <baggins@pld-linux.org> eb0980b
- updated gettext BR

* Thu Sep 11 2014 Jakub Bogusz <qboosh@pld-linux.org> c07f68a
- freetype epoch

* Sat Nov 02 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> 0f3bd77
- release 3 (by relup.sh)

* Tue Oct 29 2013 Arkadiusz Miśkiewicz <arekm@maven.pl> f117ad5
- release 2 (by relup.sh)

